"use strict";

exports.__esModule = true;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Store = function () {
  function Store() {
    _classCallCheck(this, Store);

    this._map = new Map();
    this._map.dynamicData = {};
  }

  Store.prototype.setDynamic = function setDynamic(key, fn) {
    this._map.dynamicData[key] = fn;
  };

  Store.prototype.set = function set(key, val) {
    this._map.set(key, val);
  };

  Store.prototype.get = function get(key) {
    if (this._map.has(key)) {
      return this._map.get(key);
    } else {
      if (Object.prototype.hasOwnProperty.call(this._map.dynamicData, key)) {
        var val = this._map.dynamicData[key]();
        this._map.set(key, val);
        return val;
      }
    }
  };

  return Store;
}();

exports.default = Store;